varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 diamond_center;
uniform vec2 diamond_rect;
uniform float f_addcolor;

void main(void)
{
    float diamond_width = diamond_rect.x;
    float diamond_height = diamond_rect.y;
    float x1 = diamond_center.x - diamond_width / 2.0;
    float y1 = diamond_center.y;
    float x3 = diamond_center.x + diamond_width / 2.0;
    float y3 = diamond_center.y;
    float x4 = diamond_center.x;
    float y4 = diamond_center.y - diamond_height / 2.0;
    float x = gl_FragCoord.x;
    float y = gl_FragCoord.y;
    vec4 color = texture2D(CC_Texture0, v_texCoord);
    if((x4 - x3) * (y - y3) - (y4 - y3) * (x - x3) <= 0.0
       && (x1 - x4) * (y - y4) - (y1 - y4) * (x - x4) <= 0.0)
    {
        float R = color.r;
        float G = color.g;
        float B = color.b;
        R = clamp(R + f_addcolor, 0.0, 1.0);
        G = clamp(G + f_addcolor, 0.0, 1.0);
        B = clamp(B + f_addcolor, 0.0, 1.0);
        gl_FragColor = vec4(R, G, B, color.a);
    }
    else
    {
        gl_FragColor = vec4(color.r,
                            color.g,
                            color.b,
                            0.0);
    }
}